diff --git a/gcc/analyzer/constraint-manager.h b/gcc/analyzer/constraint-manager.h
index e65ad827ce2..8fae2b488b1 100644
--- a/gcc/analyzer/constraint-manager.h
+++ b/gcc/analyzer/constraint-manager.h
@@ -18,11 +18,280 @@ You should have received a copy of the GNU General Public License
 along with GCC; see the file COPYING3.  If not see
 <http://www.gnu.org/licenses/>.  */
 
-#ifndef GCC_ANALYZER_CONSTRAINT_MANAGER_H
-#define GCC_ANALYZER_CONSTRAINT_MANAGER_H
+#ifndef GCC_ANALYZER_CONSTRAINT_MANAGER2_H
+#define GCC_ANALYZER_CONSTRAINT_MANAGER2_H
 
 namespace ana {
 
+class constraint_manager2;
+
+/* One of the end-points of a range2.  */
+
+struct bound2
+{
+  bound2 () : m_constant (NULL_TREE), m_closed (false) {}
+  bound2 (tree constant, bool closed)
+  : m_constant (constant), m_closed (closed) {}
+
+  void ensure_closed (bool is_upper);
+
+  const char * get_relation_as_str () const;
+
+  tree m_constant;
+  bool m_closed;
+};
+
+/* A range of values, used for determining if a value has been
+   constrained to just one possible constant value.  */
+
+struct range2
+{
+  range2 () : m_lower_bound (), m_upper_bound () {}
+  range2 (const bound2 &lower, const bound2 &upper)
+  : m_lower_bound (lower), m_upper_bound (upper) {}
+
+  void dump_to_pp (pretty_printer *pp) const;
+  void dump () const;
+
+  tree constrained_to_single_element ();
+
+  tristate eval_condition (enum tree_code op,
+			   tree rhs_const) const;
+  bool below_lower_bound (tree rhs_const) const;
+  bool above_upper_bound (tree rhs_const) const;
+
+  bound2 m_lower_bound;
+  bound2 m_upper_bound;
+};
+
+/* An equivalence class within a constraint manager: a set of
+   svalue_ids that are known to all be equal to each other,
+   together with an optional tree constant that they are equal to.  */
+
+class equiv_class2
+{
+public:
+  equiv_class2 ();
+  equiv_class2 (const equiv_class2 &other);
+
+  hashval_t hash () const;
+  bool operator== (const equiv_class2 &other);
+
+  void add (const svalue2 *sval);
+  bool del (const svalue2 *sval);
+
+  tree get_any_constant () const { return m_constant; }
+
+  const svalue2 *get_representative () const;
+
+  void canonicalize ();
+
+  void print (pretty_printer *pp) const;
+
+  /* An equivalence class can contain multiple constants (e.g. multiple
+     different zeroes, for different types); these are just for the last
+     constant added.  */
+  tree m_constant;
+  const svalue2 *m_cst_sval;
+
+  // TODO: should this be a set rather than a vec?
+  auto_vec<const svalue2 *> m_vars;
+};
+
+/* The various kinds of constraint.  */
+
+enum constraint2_op
+{
+  CONSTRAINT2_NE,
+  CONSTRAINT2_LT,
+  CONSTRAINT2_LE
+};
+
+const char *constraint_op_code (enum constraint2_op c_op);
+
+/* An ID for an equiv_class2 within a constraint_manager2.  Internally, this
+   is an index into a vector of equiv_class2 * within the constraint_manager2.  */
+
+class equiv_class2_id
+{
+public:
+  static equiv_class2_id null () { return equiv_class2_id (-1); }
+
+  equiv_class2_id (unsigned idx) : m_idx (idx) {}
+  const equiv_class2 &get_obj (const constraint_manager2 &cm) const;
+  equiv_class2 &get_obj (constraint_manager2 &cm) const;
+
+  bool operator== (const equiv_class2_id &other) const
+  {
+    return m_idx == other.m_idx;
+  }
+  bool operator!= (const equiv_class2_id &other) const
+  {
+    return m_idx != other.m_idx;
+  }
+
+  bool null_p () const { return m_idx == -1; }
+
+  static equiv_class2_id from_int (int idx) { return equiv_class2_id (idx); }
+  int as_int () const { return m_idx; }
+
+  void print (pretty_printer *pp) const;
+
+  void update_for_removal (equiv_class2_id other)
+  {
+    if (m_idx > other.m_idx)
+      m_idx--;
+  }
+
+  int m_idx;
+};
+
+/* A relationship between two equivalence classes in a constraint_manager2.  */
+
+class constraint2
+{
+ public:
+  constraint2 (equiv_class2_id lhs, enum constraint2_op c_op, equiv_class2_id rhs)
+  : m_lhs (lhs), m_op (c_op), m_rhs (rhs)
+  {
+    gcc_assert (!lhs.null_p ());
+    gcc_assert (!rhs.null_p ());
+  }
+
+  void print (pretty_printer *pp, const constraint_manager2 &cm) const;
+
+  hashval_t hash () const;
+  bool operator== (const constraint2 &other) const;
+
+  /* Is this an ordering, rather than a "!=".  */
+  bool is_ordering_p () const
+  {
+    return m_op != CONSTRAINT2_NE;
+  }
+
+  bool implied_by (const constraint2 &other,
+		   const constraint_manager2 &cm) const;
+
+  equiv_class2_id m_lhs;
+  enum constraint2_op m_op;
+  equiv_class2_id m_rhs;
+};
+
+/* An abstract base class for use with constraint_manager2::for_each_fact.  */
+
+class fact2_visitor
+{
+ public:
+  virtual ~fact2_visitor () {}
+  virtual void on_fact (const svalue2 *lhs,
+			enum tree_code,
+			const svalue2 *rhs) = 0;
+};
+
+/* A collection of equivalence classes and constraints on them.
+
+   Given N svalue2s, this can be thought of as representing a subset of
+   N-dimensional space.  When we call add_constraint,
+   we are effectively taking an intersection with that constraint.  */
+
+class constraint_manager2
+{
+public:
+  constraint_manager2 (region_model2_manager *mgr) : m_mgr (mgr) {}
+  constraint_manager2 (const constraint_manager2 &other);
+  virtual ~constraint_manager2 () {}
+
+#if 0
+  virtual constraint_manager2 *clone (region_model2 *) const = 0;
+#endif
+  constraint_manager2& operator= (const constraint_manager2 &other);
+
+  hashval_t hash () const;
+  bool operator== (const constraint_manager2 &other) const;
+  bool operator!= (const constraint_manager2 &other) const
+  {
+    return !(*this == other);
+  }
+
+  void print (pretty_printer *pp) const;
+  void dump_to_pp (pretty_printer *pp, bool multiline) const;
+  void dump (FILE *fp) const;
+  void dump () const;
+
+  const equiv_class2 &get_equiv_class2_by_index (unsigned idx) const
+  {
+    return *m_equiv_classes[idx];
+  }
+  equiv_class2 &get_equiv_class2_by_index (unsigned idx)
+  {
+    return *m_equiv_classes[idx];
+  }
+
+  equiv_class2 &get_equiv_class2 (const svalue2 *sval)
+  {
+    equiv_class2_id ec_id = get_or_add_equiv_class2 (sval);
+    return ec_id.get_obj (*this);
+  }
+
+  bool add_constraint (const svalue2 *lhs,
+		       enum tree_code op,
+		       const svalue2 *rhs);
+
+  bool add_constraint (equiv_class2_id lhs_ec_id,
+		       enum tree_code op,
+		       equiv_class2_id rhs_ec_id);
+
+  void add_unknown_constraint (equiv_class2_id lhs_ec_id,
+			       enum tree_code op,
+			       equiv_class2_id rhs_ec_id);
+
+  bool get_equiv_class2_by_svalue2 (const svalue2 *sval,
+				    equiv_class2_id *out) const;
+  equiv_class2_id get_or_add_equiv_class2 (const svalue2 *sval);
+  tristate eval_condition (equiv_class2_id lhs,
+			   enum tree_code op,
+			   equiv_class2_id rhs) const;
+  tristate eval_condition (equiv_class2_id lhs_ec,
+			   enum tree_code op,
+			   tree rhs_const) const;
+  tristate eval_condition (const svalue2 *lhs,
+			   enum tree_code op,
+			   const svalue2 *rhs) const;
+  range2 get_ec_bounds (equiv_class2_id ec_id) const;
+
+  /* PurgeCriteria should have:
+     bool should_purge_p (const svalue2 *sval) const.  */
+  template <typename PurgeCriteria>
+  void purge (const PurgeCriteria &p, purge_stats2 *stats);
+
+  void on_liveness_change (const hash_set<const svalue2 *> &live_svalues,
+			   const region_model2 *model);
+
+  void canonicalize ();
+
+  static void merge (const constraint_manager2 &cm_a,
+		     const constraint_manager2 &cm_b,
+		     constraint_manager2 *out,
+		     const model2_merger &merger);
+
+  void for_each_fact (fact2_visitor *) const;
+
+  void validate () const;
+
+  auto_delete_vec<equiv_class2> m_equiv_classes;
+  auto_vec<constraint2> m_constraints;
+
+ private:
+  static void clean_merger_input (const constraint_manager2 &cm_in,
+				  constraint_manager2 *out);
+
+  void add_constraint_internal (equiv_class2_id lhs_id,
+				enum constraint2_op c_op,
+				equiv_class2_id rhs_id);
+
+  region_model2_manager *m_mgr;
+};
+
 } // namespace ana
 
-#endif /* GCC_ANALYZER_CONSTRAINT_MANAGER_H */
+#endif /* GCC_ANALYZER_CONSTRAINT_MANAGER2_H */
diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index 0808cadeeef..65c8172eeb9 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -40,7 +40,6 @@ along with GCC; see the file COPYING3.  If not see
 #include "analyzer/analyzer.h"
 #include "analyzer/analyzer-logging.h"
 #include "analyzer/region-model.h"
-#include "analyzer/region-model2.h"
 #include "analyzer/constraint-manager.h"
 #include "analyzer/sm.h"
 #include "analyzer/pending-diagnostic.h"
diff --git a/gcc/analyzer/exploded-graph.h b/gcc/analyzer/exploded-graph.h
index 003bded829d..1655a4ad878 100644
--- a/gcc/analyzer/exploded-graph.h
+++ b/gcc/analyzer/exploded-graph.h
@@ -21,7 +21,7 @@ along with GCC; see the file COPYING3.  If not see
 #ifndef GCC_ANALYZER_EXPLODED_GRAPH_H
 #define GCC_ANALYZER_EXPLODED_GRAPH_H
 
-#include "region-model2.h" // FIXME
+#include "region-model.h" // FIXME
 
 namespace ana {
 
diff --git a/gcc/analyzer/program-state.cc b/gcc/analyzer/program-state.cc
index ae444ada7f3..f80f10dca84 100644
--- a/gcc/analyzer/program-state.cc
+++ b/gcc/analyzer/program-state.cc
@@ -34,14 +34,11 @@ along with GCC; see the file COPYING3.  If not see
 #include "ordered-hash-map.h"
 #include "selftest.h"
 #include "analyzer/region-model.h"
-#include "analyzer/region-model2.h"
 #include "analyzer/program-state.h"
 #include "analyzer/constraint-manager.h"
-#include "analyzer/constraint-manager2.h"
 #include "alloc-pool.h"
 #include "fibonacci_heap.h"
 #include "shortest-paths.h"
-#include "analyzer/constraint-manager.h"
 #include "diagnostic-event-id.h"
 #include "analyzer/pending-diagnostic.h"
 #include "analyzer/diagnostic-manager.h"
diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 48eb491b6d6..1bbafdee7a5 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -22,6 +22,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "system.h"
 #include "coretypes.h"
 #include "tree.h"
+#include "gimple-pretty-print.h"
 #include "function.h"
 #include "basic-block.h"
 #include "gimple.h"
@@ -58,8 +59,12 @@ along with GCC; see the file COPYING3.  If not see
 #include "diagnostic-event-id.h"
 #include "analyzer/sm.h"
 #include "analyzer/pending-diagnostic.h"
+#include "analyzer/region-model2-reachability.h"
 #include "analyzer/analyzer-selftests.h"
 #include "stor-layout.h"
+#include "value-range.h" // for tree-ssanames.h
+#include "gimple-ssa.h" // for struct gimple_df in FOR_EACH_SSA_NAME
+#include "tree-ssanames.h" // for FOR_EACH_SSA_NAME
 
 #if ENABLE_ANALYZER
 
@@ -104,37 +109,711 @@ print_quoted_type (pretty_printer *pp, tree t)
   pp_end_quote (pp, pp_show_color (pp));
 }
 
-/* Dump this path_var to PP (which must support %E for trees).
+/* For use in printing a comma-separated list.  */
 
-   Express the stack depth using an "@DEPTH" suffix, so e.g. given
-     void foo (int j);
-     void bar (int i)
-     {
-       foo (i);
-     }
-   then:
-   - the "i" in "bar" would be "(i @ 0)"
-   - the "j" in "foo" would be "(j @ 1)".  */
+static void
+dump_separator (pretty_printer *pp, bool *is_first)
+{
+  if (!*is_first)
+    pp_string (pp, ", ");
+  *is_first = false;
+}
+
+#if 0
+/* Concrete subclass of constraint_manager that wires it up to a region_model2
+   (whilst allowing the constraint_manager and region_model2 to be somewhat
+   at arms length).
+   TODO: revisit this; maybe put the region_model2 * into the constraint_manager
+   base class.  */
+
+class impl_constraint_manager : public constraint_manager
+{
+ public:
+  impl_constraint_manager (region_model2 *model)
+  : constraint_manager (),
+    m_model (model)
+  {}
+
+  impl_constraint_manager (const impl_constraint_manager &other,
+			   region_model2 *model)
+  : constraint_manager (other),
+    m_model (model)
+  {}
+
+  constraint_manager *clone (region_model2 *model) const
+  {
+    return new impl_constraint_manager (*this, model);
+  }
+
+  tree maybe_get_constant (const svalue2 *sval) const FINAL OVERRIDE
+  {
+    const svalue2 *svalue2 = m_model->get_svalue2 (sid);
+    return svalue2->maybe_get_constant ();
+  }
+
+  svalue2_id get_sid_for_constant (tree cst) const FINAL OVERRIDE
+  {
+    gcc_assert (CONSTANT_CLASS_P (cst));
+    return m_model->get_rvalue (cst, NULL);
+  }
+
+  int get_num_svalue2s () const FINAL OVERRIDE
+  {
+    return m_model->get_num_svalue2s ();
+  }
+
+ private:
+  region_model2 *m_model;
+};
+#endif
+
+/* struct complexity.  */
+
+/* Get complexity for a new node that references REG
+   (the complexity of REG, plus one for the new node).  */
+
+complexity::complexity (const region2 *reg)
+: m_num_nodes (reg->get_complexity ().m_num_nodes + 1),
+  m_max_depth (reg->get_complexity ().m_max_depth + 1)
+{
+}
+
+/* Get complexity for a new node that references SVAL.
+   (the complexity of SVAL, plus one for the new node).  */
+
+complexity::complexity (const svalue2 *sval)
+: m_num_nodes (sval->get_complexity ().m_num_nodes + 1),
+  m_max_depth (sval->get_complexity ().m_max_depth + 1)
+{
+}
+
+/* Get complexity for a new node that references nodes with complexity
+   C1 and C2.  */
+
+complexity
+complexity::from_pair (const complexity &c1, const complexity &c2)
+{
+  return complexity (c1.m_num_nodes + c2.m_num_nodes + 1,
+		     MAX (c1.m_max_depth, c2.m_max_depth) + 1);
+}
 
+/* class svalue2 and its various subclasses.  */
+
+/* class svalue2.  */
+
+/* Dump this svalue2 in the form of a .dot record to PP.  */
+
+#if 0
 void
-path_var::dump (pretty_printer *pp) const
+svalue2::dump_dot_to_pp (const region_model2 &model,
+			pretty_printer *pp) const
+{
+  this_sval.dump_node_name_to_pp (pp);
+  pp_printf (pp, " [label=\"");
+  pp_write_text_to_stream (pp);
+  this_sval.print (pp);
+  pp_string (pp, ": {");
+  print (model, this_sval, pp);
+  pp_write_text_as_dot_label_to_stream (pp, /*for_record=*/false);
+  pp_string (pp, "}\"];");
+  pp_newline (pp);
+}
+#endif
+
+/* FIXME.  */
+
+DEBUG_FUNCTION void
+svalue2::dump (bool simple) const
+{
+  pretty_printer pp;
+  pp_format_decoder (&pp) = default_tree_printer;
+  pp_show_color (&pp) = pp_show_color (global_dc->printer);
+  pp.buffer->stream = stderr;
+  dump_to_pp (&pp, simple);
+  pp_newline (&pp);
+  pp_flush (&pp);
+}
+
+/* FIXME.  */
+
+label_text
+svalue2::get_desc (bool simple) const
+{
+  pretty_printer pp;
+  pp_format_decoder (&pp) = default_tree_printer;
+  dump_to_pp (&pp, simple);
+  return label_text::take (xstrdup (pp_formatted_text (&pp)));
+}
+
+/* If this svalue2 is a constant_svalue2, return the underlying tree constant.
+   Otherwise return NULL_TREE.  */
+
+tree
+svalue2::maybe_get_constant () const
 {
-  if (m_tree == NULL_TREE)
-    pp_string (pp, "NULL");
-  if (CONSTANT_CLASS_P (m_tree))
-    pp_printf (pp, "%qE", m_tree);
+  if (const constant_svalue2 *cst_sval = dyn_cast_constant_svalue2 ())
+    return cst_sval->get_constant ();
   else
-    pp_printf (pp, "(%qE @ %i)", m_tree, m_stack_depth);
+    return NULL_TREE;
 }
 
-/* For use in printing a comma-separated list.  */
+/* If this svalue2 is a cast (i.e a unaryop NOP_EXPR), return the underlying
+   svalue2.
+   Otherwise return NULL.  */
 
-static void
-dump_separator (pretty_printer *pp, bool *is_first)
+const svalue2 *
+svalue2::maybe_undo_cast () const
 {
-  if (!*is_first)
-    pp_string (pp, ", ");
-  *is_first = false;
+  if (const unaryop_svalue2 *unaryop_sval = dyn_cast_unaryop_svalue2 ())
+    if (unaryop_sval->get_op () == NOP_EXPR)
+      return unaryop_sval->get_arg ();
+  return NULL;
+}
+
+const svalue2 *
+svalue2::unwrap_any_unmergeable () const
+{
+  if (const unmergeable_svalue2 *unmergeable = dyn_cast_unmergeable_svalue2 ())
+    return unmergeable->get_arg ();
+  return this;
+}
+
+/* Attempt to merge THIS with OTHER, returning the merged svalue2.
+   Return NULL if not mergeable.  */
+
+const svalue2 *
+svalue2::can_merge_p (const svalue2 *other,
+		      region_model2_manager *mgr,
+		      model2_merger *merger) const
+{
+  if (!(get_type () && other->get_type ()))
+    return NULL;
+
+  // FIXME: should we assert this instead?
+  if (!types_compatible_p (get_type (), other->get_type ()))
+    return NULL;
+
+  /* Reject attempts to merge unmergeable svalues.  */
+  if ((get_kind () == svalue2::SK_UNMERGEABLE)
+      || (other->get_kind () == svalue2::SK_UNMERGEABLE))
+    return NULL;
+
+  /* Reject attempts to merge NULL pointers with not-NULL-pointers.  */
+  if (POINTER_TYPE_P (get_type ()))
+    {
+      bool null0 = false;
+      bool null1 = false;
+      if (tree cst0 = maybe_get_constant ())
+	if (zerop (cst0))
+	  null0 = true;
+      if (tree cst1 = other->maybe_get_constant ())
+	if (zerop (cst1))
+	  null1 = true;
+      if (null0 != null1)
+	return NULL;
+    }
+
+#if WIDENING
+  /* Widening.  */
+  /* Merge: (new_cst, existing_cst) -> widen (existing, new).  */
+  if (tree cst0 = maybe_get_constant ())
+    if (tree cst1 = other->maybe_get_constant ())
+      {
+	return mgr->get_or_create_widening_svalue2 (other->get_type (),
+						    merger->m_point,
+						    other, this);
+      }
+  /* TODO: also detect widening symbolically via binary ops
+     e.g. for (i = start; i < end; i+= step).  */
+
+  /* Merge: (Widen(existing_val, V), existing_val) -> Widen (existing_val, V)
+     and thus get a fixed point.  */
+  if (const widening_svalue2 *widen_sval = dyn_cast_widening_svalue2 ())
+    {
+      /* FIXME: which direction??? */
+      if (other == widen_sval->get_base_svalue2 ())
+	return this;
+      if (other == widen_sval->get_iter_svalue2 ())
+	return this;
+    }
+
+  if (const binop_svalue2 *binop_sval = dyn_cast_binop_svalue2 ())
+    if (const widening_svalue2 *widen_arg0
+	= binop_sval->get_arg0 ()->dyn_cast_widening_svalue2 ())
+      {
+	if (other == binop_sval->get_arg1 ())
+	  {
+	    /* Merger of: (Widen(..., OTHER) BINOP X)
+	       and      : OTHER
+	       to       : (Widen(..., OTHER) BINOP X)
+	       e.g. merge of Widen(0, 1) + 1 with 1 to the Widen(0, 1) + 1.  */
+	    return this;
+	  }
+
+	/* Merger of : (Widen() BINOP X)
+	   and       : Widen()
+	   to        : Widen()
+	   e.g. merge of Widen(0, 1) + 1 and Widen(0, 1) to Widen(0, 1).
+	   However, we want to update constraints for this case, since we're
+	   considering another iteration.
+	   Presumably we also want to ensure that it converges; we don't want
+	   a descending chain of constraints.  */
+	if (other == widen_arg0)
+	  {
+#if ITERATED_BINOPS
+	    merger->add_iterating_widening_binop_thing (binop_sval);
+#endif
+	    return widen_arg0;
+	  }
+      }
+#endif
+
+  return mgr->get_or_create_unknown_svalue2 (get_type ());
+}
+
+/* FIXME.  */
+
+bool
+svalue2::live_p (const hash_set<const svalue2 *> &live_svalues,
+		 const region_model2 *model) const
+{
+  /* Determine if SVAL is explicitly live.  */
+  if (const_cast<hash_set<const svalue2 *> &> (live_svalues).contains (this))
+    return true;
+
+  /* Otherwise, determine if SVAL is implicitly live due to being made of
+     other live svalues.  */
+  return implicitly_live_p (live_svalues, model);
+}
+
+/* Base implementation of svalue2::implicitly_live_p.  */
+
+bool
+svalue2::implicitly_live_p (const svalue2_set &, const region_model2 *) const
+{
+  return false;
+}
+
+/* FIXME: group these here, or move them to their subclass groupings.  */
+
+/* Constants are implicitly live.  */
+
+bool
+constant_svalue2::implicitly_live_p (const svalue2_set &,
+				     const region_model2 *) const
+{
+  return true;
+}
+
+bool
+initial_svalue2::implicitly_live_p (const svalue2_set &live_svalues,
+				    const region_model2 *model) const
+{
+  /* This svalue2 may be implicitly live if the region still implicitly
+     has its initial value and is reachable.  */
+
+  /* It must be a region that exists; we don't want to consider
+     INIT_VAL(R) as still being implicitly reachable if R is in
+     a popped stack frame.  */
+  if (model->region_exists_p (m_reg))
+    {
+      const svalue2 *reg_sval = model->get_store_value (m_reg);
+      if (reg_sval == this)
+	return true;
+    }
+
+  return false;
+}
+
+bool
+unaryop_svalue2::implicitly_live_p (const svalue2_set &live_svalues,
+				    const region_model2 *model) const
+{
+  return get_arg ()->live_p (live_svalues, model);
+}
+
+bool
+binop_svalue2::implicitly_live_p (const svalue2_set &live_svalues,
+				  const region_model2 *model) const
+{
+  return (get_arg0 ()->live_p (live_svalues, model)
+	  && get_arg1 ()->live_p (live_svalues, model));
+}
+
+bool
+sub_svalue2::implicitly_live_p (const svalue2_set &live_svalues,
+				const region_model2 *model) const
+{
+  return get_parent ()->live_p (live_svalues, model);
+}
+
+bool
+unmergeable_svalue2::implicitly_live_p (const svalue2_set &live_svalues,
+					const region_model2 *model) const
+{
+  return get_arg ()->live_p (live_svalues, model);
+}
+
+/* class region_svalue2 : public svalue2.  */
+
+/* FIXME.  */
+
+void
+region_svalue2::dump_to_pp (pretty_printer *pp, bool simple) const
+{
+  if (simple)
+    {
+      pp_string (pp, "&");
+      m_reg->dump_to_pp (pp, simple);
+    }
+  else
+    {
+      pp_string (pp, "region_svalue2(");
+      print_quoted_type (pp, get_type ());
+      pp_string (pp, ", ");
+      m_reg->dump_to_pp (pp, simple);
+      pp_string (pp, ")");
+    }
+}
+
+/* Compare the fields of this region_svalue2 with OTHER, returning true
+   if they are equal.
+   For use by svalue2::operator==.  */
+#if 0
+bool
+region_svalue2::compare_fields (const region_svalue2 &other) const
+{
+  return m_reg == other.m_reg;
+}
+#endif
+
+/* FIXME.  */
+
+void
+region_svalue2::accept (visitor *v) const
+{
+  v->visit_region_svalue2 (this);
+  m_reg->accept (v);
+}
+
+/* Implementation of svalue2::dump_dot_to_pp for region_svalue2.  */
+
+#if 0
+void
+region_svalue2::dump_dot_to_pp (const region_model2 &model,
+			       svalue2_id this_sval,
+			       pretty_printer *pp) const
+{
+  svalue2::dump_dot_to_pp (model, this_sval, pp);
+
+  /* If non-NULL, add an edge to the pointed-to region2.  */
+  if (!m_reg.null_p ())
+    {
+      this_sval.dump_node_name_to_pp (pp);
+      pp_string (pp, " -> ");
+      m_reg.dump_node_name_to_pp (pp);
+      pp_string (pp, ";");
+      pp_newline (pp);
+  }
+}
+#endif
+
+#if 0
+/* Merge REGION2_SVAL_A and REGION2_SVAL_B using MERGER, writing the result
+   into *MERGED_SVAL.  */
+
+void
+region_svalue2::merge_values (const region_svalue2 &region2_sval_a,
+			     const region_svalue2 &region2_sval_b,
+			     svalue2_id *merged_sval,
+			     tree type,
+			     model_merger *merger)
+{
+  region2_id a_reg = region2_sval_a.get_pointee ();
+  region2_id b_reg = region2_sval_b.get_pointee ();
+
+  /* Both are non-NULL. */
+  gcc_assert (!a_reg.null_p () && !b_reg.null_p ());
+
+  /* Have these ptr-values already been merged?  */
+
+  region2_id a_reg_in_m
+    = merger->m_map_region2s_from_a_to_m.get_dst_for_src (a_reg);
+  region2_id b_reg_in_m
+    = merger->m_map_region2s_from_b_to_m.get_dst_for_src (b_reg);
+
+  /* "null_p" here means "we haven't seen this ptr-value before".
+     If we've seen one but not the other, or we have different
+     region2s, then the merged ptr has to be "unknown".  */
+  if (a_reg_in_m != b_reg_in_m)
+    {
+      const svalue2 *merged_sval = new unknown_svalue2 (type);
+      *merged_sval = merger->m_merged_model->add_svalue2 (merged_sval);
+      return;
+    }
+
+  /* Have we seen this yet?  If so, reuse the value.  */
+  if (!a_reg_in_m.null_p ())
+    {
+      *merged_sval
+	= merger->m_merged_model->get_or_create_ptr_svalue2 (type, a_reg_in_m);
+      return;
+    }
+
+  /* Otherwise we have A/B region2s that haven't been referenced yet.  */
+
+  /* Are the region2s the "same", when seen from the tree point-of-view.
+     If so, create a merged pointer to it.  */
+  path_var pv_a = merger->m_model_a->get_representative_path_var (a_reg);
+  path_var pv_b = merger->m_model_b->get_representative_path_var (b_reg);
+  if (pv_a.m_tree
+      && pv_a == pv_b)
+    {
+      region2_id merged_pointee_reg
+	= merger->m_merged_model->get_lvalue (pv_a, NULL);
+      *merged_sval
+	= merger->m_merged_model->get_or_create_ptr_svalue2 (type,
+							    merged_pointee_reg);
+      merger->record_region2s (a_reg, b_reg, merged_pointee_reg);
+      return;
+    }
+
+  /* Handle an A/B pair of ptrs that both point at heap region2s.
+     If they both have a heap region2 in the merger model, merge them.  */
+  region2 *region2_a = merger->m_model_a->get_region2 (a_reg);
+  region2 *region2_b = merger->m_model_b->get_region2 (b_reg);
+  region2_id a_parent_reg = region2_a->get_parent ();
+  region2_id b_parent_reg = region2_b->get_parent ();
+  region2 *parent_region2_a = merger->m_model_a->get_region2 (a_parent_reg);
+  region2 *parent_region2_b = merger->m_model_b->get_region2 (b_parent_reg);
+  if (parent_region2_a
+      && parent_region2_b
+      && parent_region2_a->get_kind () == RK_HEAP
+      && parent_region2_b->get_kind () == RK_HEAP)
+    {
+	/* We have an A/B pair of ptrs that both point at heap region2s.  */
+	/* presumably we want to see if each A/B heap region2 already
+	   has a merged region2, and, if so, is it the same one.  */
+	// This check is above
+
+	region2_id merged_pointee_reg
+	  = merger->m_merged_model->add_new_malloc_region2 ();
+	*merged_sval
+	  = merger->m_merged_model->get_or_create_ptr_svalue2
+	     (type, merged_pointee_reg);
+	merger->record_region2s (a_reg, b_reg, merged_pointee_reg);
+	return;
+    }
+
+  /* Two different non-NULL pointers?  Merge to unknown.  */
+  const svalue2 *merged_sval = new unknown_svalue2 (type);
+  *merged_sval = merger->m_merged_model->add_svalue2 (merged_sval);
+  return;
+}
+#endif
+
+/* Evaluate the condition LHS OP RHS.
+   Subroutine of region_model2::eval_condition for when we have a pair of
+   pointers.  */
+
+tristate
+region_svalue2::eval_condition (const region_svalue2 *lhs,
+				enum tree_code op,
+				const region_svalue2 *rhs)
+{
+  /* See if they point to the same region2.  */
+  const region2 *lhs_reg = lhs->get_pointee ();
+  const region2 *rhs_reg = rhs->get_pointee ();
+  bool ptr_equality = lhs_reg == rhs_reg;
+  // FIXME: what about when we have unknown values?
+  /* TODO: what about child region2s where the child is the first child
+     (or descendent)?
+     Presumably we should look at base regions and compare offsets
+     within them.  */
+  switch (op)
+    {
+    default:
+      gcc_unreachable ();
+
+    case EQ_EXPR:
+      if (ptr_equality)
+	return tristate::TS_TRUE;
+      else
+	return tristate::TS_FALSE;
+      break;
+
+    case NE_EXPR:
+      if (ptr_equality)
+	return tristate::TS_FALSE;
+      else
+	return tristate::TS_TRUE;
+      break;
+
+    case GE_EXPR:
+    case LE_EXPR:
+      if (ptr_equality)
+	return tristate::TS_TRUE;
+      break;
+
+    case GT_EXPR:
+    case LT_EXPR:
+      if (ptr_equality)
+	return tristate::TS_FALSE;
+      break;
+    }
+
+  return tristate::TS_UNKNOWN;
+}
+
+/* class constant_svalue2 : public svalue2.  */
+
+/* FIXME.  */
+
+void
+constant_svalue2::dump_to_pp (pretty_printer *pp, bool simple) const
+{
+  if (simple)
+    {
+      pp_string (pp, "(");
+      dump_tree (pp, get_type ());
+      pp_string (pp, ")");
+      dump_tree (pp, m_cst_expr);
+    }
+  else
+    {
+      pp_string (pp, "constant_svalue2(");
+      print_quoted_type (pp, get_type ());
+      pp_string (pp, ", ");
+      dump_tree (pp, m_cst_expr);
+      pp_string (pp, ")");
+    }
+}
+
+/* FIXME.  */
+
+void
+constant_svalue2::accept (visitor *v) const
+{
+  v->visit_constant_svalue2 (this);
+}
+
+/* Compare the fields of this constant_svalue2 with OTHER, returning true
+   if they are equal.
+   For use by svalue2::operator==.  */
+#if 0
+bool
+constant_svalue2::compare_fields (const constant_svalue2 &other) const
+{
+  return m_cst_expr == other.m_cst_expr;
+}
+#endif
+
+/* Merge the CST_SVAL_A and CST_SVAL_B using MERGER, writing the id of
+   the resulting svalue2 into *MERGED_SVAL.  */
+#if 0
+void
+constant_svalue2::merge_values (const constant_svalue2 &cst_sval_a,
+			       const constant_svalue2 &cst_sval_b,
+			       svalue2_id *merged_sval,
+			       model_merger *merger)
+{
+  tree cst_a = cst_sval_a.get_constant ();
+  tree cst_b = cst_sval_b.get_constant ();
+  const svalue2 *merged_sval;
+  if (cst_a == cst_b)
+    {
+      /* If they are the same constant, merge as that constant value.  */
+      merged_sval = new constant_svalue2 (cst_a);
+    }
+  else
+    {
+      /* Otherwise, we have two different constant values.
+	 Merge as an unknown value.
+	 TODO: impose constraints on the value?
+	 (maybe just based on A, to avoid infinite chains)  */
+      merged_sval = new unknown_svalue2 (TREE_TYPE (cst_a));
+    }
+  *merged_sval = merger->m_merged_model->add_svalue2 (merged_sval);
+}
+#endif
+
+/* Evaluate the condition LHS OP RHS.
+   Subroutine of region_model2::eval_condition for when we have a pair of
+   constants.  */
+
+tristate
+constant_svalue2::eval_condition (const constant_svalue2 *lhs,
+				  enum tree_code op,
+				  const constant_svalue2 *rhs)
+{
+  tree lhs_const = lhs->get_constant ();
+  tree rhs_const = rhs->get_constant ();
+
+  gcc_assert (CONSTANT_CLASS_P (lhs_const));
+  gcc_assert (CONSTANT_CLASS_P (rhs_const));
+
+  /* Check for comparable types.  */
+  if (types_compatible_p (TREE_TYPE (lhs_const), TREE_TYPE (rhs_const)))
+    {
+      tree comparison
+	= fold_binary (op, boolean_type_node, lhs_const, rhs_const);
+      if (comparison == boolean_true_node)
+	return tristate (tristate::TS_TRUE);
+      if (comparison == boolean_false_node)
+	return tristate (tristate::TS_FALSE);
+    }
+  return tristate::TS_UNKNOWN;
+}
+
+/* Implementation of svalue2::get_child_sval vfunc for constant_svalue2.  */
+#if 0
+svalue2_id
+constant_svalue2::get_child_sval (region2 *parent ATTRIBUTE_UNUSED,
+				region2 *child,
+				region_model2 &model,
+				region_model2_context *ctxt ATTRIBUTE_UNUSED)
+{
+  /* TODO: handle the all-zeroes case by returning an all-zeroes of the
+     child type.  */
+
+  /* Otherwise, we don't have a good way to get a child value out of a
+     constant.
+
+     Handle this case by using an unknown value.  */
+  const svalue2 *unknown_sval = new unknown_svalue2 (child->get_type ());
+  return model.add_svalue2 (unknown_sval);
+}
+#endif
+
+/* class unknown_svalue2 : public svalue2.  */
+
+/* FIXME.  */
+
+void
+unknown_svalue2::dump_to_pp (pretty_printer *pp, bool simple) const
+{
+  if (simple)
+    {
+      pp_string (pp, "UNKNOWN(");
+      if (get_type ())
+	dump_tree (pp, get_type ());
+      pp_character (pp, ')');
+    }
+  else
+    {
+      pp_string (pp, "unknown_svalue2(");
+      if (get_type ())
+	dump_tree (pp, get_type ());
+      pp_character (pp, ')');
+    }
+}
+
+/* FIXME.  */
+
+void
+unknown_svalue2::accept (visitor *v) const
+{
+  v->visit_unknown_svalue2 (this);
 }
 
 /* Get a string for KIND for use in debug dumps.  */
